package com.anabas.pdasharedlet;

/**
 * Title:        GSDListener.java
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      CSIT FSU
 * @author       Sangyoon Oh soh@csit.fsu.edu
 * @version 0.1
 */

import com.anabas.sdsharedlet.*;

import com.anabas.concepts.*;
import com.anabas.sharedlet.*;
import com.anabas.util.misc.LogManager;
import com.anabas.gxo.*;
import com.anabas.naming.*;

import com.anabas.sdsharedlet.*;

public class GSDListener extends Thread implements GMS_MessageListener {

  private PdaControlView pcv;
  private SDSharedlet m_sdsharedlet;
  private GMS_StreamSubscriber m_subscriber;
  private boolean recieveMessage = false;

  public GSDListener(PdaControlView o_pcv, SDSharedlet o_sdsharedlet,
                     GMS_StreamSubscriber o_subscriber) {
    this.pcv = o_pcv;
    this.m_sdsharedlet = o_sdsharedlet;
    this.m_subscriber = o_subscriber;
  }

  public void run() {

    /**
    SDBitmap sdbitmap = m_sdsharedlet.getBitmap(0);
    pcv.pa.getSDMessage(sdbitmap);
    System.out.println("[PDA-ADAPTOR] Send Bitmap");
    **/

    while(true) {
      if(recieveMessage && pcv.pa.isSDChanged) {
      //if(pcv.pa.isSDChanged) {
        SDBitmap sdbitmap = m_sdsharedlet.getBitmap(0);
        pcv.pa.getSDMessage(sdbitmap);
        System.out.println("[PDA-ADAPTOR] Send Bitmap");
      }

      try {
        // wait for 10 sec.
        Thread.sleep(10000);
      }
      catch(InterruptedException e) {
        System.out.println(e.toString() );
      }

      recieveMessage = false;
    }
  }

  /**
   * When it receives a message from the bus containing a new random number
   * that was generated by another user, display it in the presentation area.
   */
  public void onMessage(GMS_Message m) {
    try {
      recieveMessage = true;
      GMS_TextMessage msg = (GMS_TextMessage)m;
      String text = (String)msg.getText();
    }
    catch (GXO_Exception e) {
      LogManager.err("GSDListener", "error on message",e);
    }
  }

  public void onRequest(GMS_Message m,GMS_MessageReplyer r) {}
}