/*********************************************************
    HHMPUtil.java
      last update  : May,11,2001
      author       : Sangmi Lee (slee@csit.fsu.edu)
**********************************************************/
package com.anabas.pdasharedlet;


class HHMPUtil{

    private int taglength = 5;
    

    public HHMPUtil() {}

    public byte[] GenerateHHMPmessage(byte mid, byte aid, byte tid, byte eid1, byte eid2, 
                                      byte[] message, int length) {
        byte [] returnbytes = new byte[length+taglength];
        returnbytes[0] = mid ;
        returnbytes[1] = aid ;
        returnbytes[2] = tid ;
        returnbytes[3] = eid1;
        returnbytes[4] = eid2;
        for (int i = 0; i<length; i++)
           returnbytes[i+taglength] = message[i];

        return returnbytes;

    }
    public byte[] GenerateHHMPmessage(byte mid, byte aid, byte tid, byte eid1, byte eid2, 
                                      int width, int height, int length) {
        byte [] returnbytes = new byte[length+taglength];
        returnbytes[0] = mid ;
        returnbytes[1] = aid ;
        returnbytes[2] = tid ;
        returnbytes[3] = eid1;
        returnbytes[4] = eid2;
        byte [] tmpbyte = new byte[3];
        tmpbyte = IntToByte(width);
        returnbytes[5] = tmpbyte[0];
        returnbytes[6] = tmpbyte[1];
        returnbytes[7] = tmpbyte[2];

        tmpbyte = new byte[3];
        tmpbyte = IntToByte(height);
        returnbytes[ 8] = tmpbyte[0];
        returnbytes[ 9] = tmpbyte[1];
        returnbytes[10] = tmpbyte[2];
        return returnbytes;

    }



    public byte[] GenerateHHMPmessage(byte mid, byte aid, byte tid, byte eid1, byte eid2,
                                      int[] message, int length){
        System.out.println(" 0pixel genereate message started"); 
        byte [] returnbytes = new byte[(length * 3) + taglength];
        byte [] tmpbytes = new byte[length * 3];
        returnbytes[0] = mid;
        returnbytes[1] = aid;
        returnbytes[2] = tid;
        returnbytes[3] = eid1;
        returnbytes[4] = eid2;
        System.out.println(" 1pixel genereate message started"); 

        tmpbytes = PixelsToBytes(message,length); 
        System.out.println(" 2pixel genereate message started"); 

        for (int i = 0; i < (length *3); i++)
            returnbytes[taglength + i ] = tmpbytes[i];
        for(int i = 0 ; i < length; i=i+3000 ) System.out.println("HHMP bytes are, " +
                                      tmpbytes[i+0] + " " + tmpbytes[i+1] + " " +
                                      tmpbytes[i+2] + " " + tmpbytes[i+3]);
        for(int i = 0 ; i < length; i=i+3000 ) System.out.println("return bytes are, " +
                                      returnbytes[i+0] + " " + returnbytes[i+1] + " " +
                                      returnbytes[i+2] + " " + returnbytes[i+3]);


        return returnbytes;
    }
       



 
    public byte[] PixelsToBytes(int[] pixels, int length) {
           System.out.println(" 5pixel genereate message started"); 
 
           byte [] returnbyte = new byte[length*3];
           for (int i = 0; i<length; i++){ 
               
               //System.out.println("6 pixel genereate message started"+length+" "+i); 

               Integer R = new Integer((pixels[i]>>16)& 0x000000FF);
               Integer G = new Integer((pixels[i]>> 8)& 0x000000FF);
               Integer B = new Integer((pixels[i]    )& 0x000000FF); 
               returnbyte[i*3+0] = R.byteValue();
               returnbyte[i*3+1] = G.byteValue();
               returnbyte[i*3+2] = B.byteValue();
            }
            System.out.println("7 pixel genereate message started"); 

            return returnbyte;
    }


   public int[] BytesToPixels(byte[] bytepixels, int width, int height) {

               int[] returnpixel = new int[width*height];
               
               for (int i = 0; i<width*height; i++){ 
                   returnpixel[i] =   
                       (((int)bytepixels[i*3+0]) & 0x00FF0000) +
                       (((int)bytepixels[i*3+1]) & 0x0000FF00) +
                       (((int)bytepixels[i*3+2]) & 0x000000FF);             
               }
               return returnpixel;
    }


    public byte[] IntToByte(int inputint){
               byte[] returnbyte = new byte[3];
              
               Integer buf0 = new Integer((inputint>>16)& 0x000000FF);
               Integer buf1 = new Integer((inputint>> 8)& 0x000000FF);
               Integer buf2 = new Integer((inputint    )& 0x000000FF);
              
               returnbyte[0] = buf0.byteValue();
               returnbyte[1] = buf1.byteValue();
               returnbyte[2] = buf2.byteValue();
               return returnbyte;
    }
 
    public int ByteToInt(byte[] inputbyte, int s){
               int returnint;
               returnint =
                           (((int)inputbyte[s+0]<<16) & 0x00FF0000) +
                           (((int)inputbyte[s+1]<< 8) & 0x0000FF00) +
                           (((int)inputbyte[s+2]    ) & 0x000000FF);
               return returnint;
    }  
                 
             
}
