package com.anabas.pdasharedlet;

/**
 * Title:        HHMPconverter.java
 * Description:  HHMP converter class.
 *               converting from HHMP to hashtable and from hashtable to HHMP
 * Copyright:    Copyright (c) 2001
 * Company:      CSIT FSU
 * @author       Sangyoon Oh soh@csit.fsu.edu
 * @version 0.1
 */

import java.lang.*;
import java.util.*;

public class HHMPconverter {

  /**
   * get the HHMP byte[] and convert into hashtable
   *
   * @param   HHMP byte[] and size of HHMP
   *          return hashtable
   */
  public Hashtable HHMPtoplain(byte[] HHMP, int hhmsSize){
    Hashtable hash = new Hashtable();
    String message = new String(HHMP);

    hash.put("mid", new String(HHMP, 0, 1));
    hash.put("aid", new String(HHMP, 1, 1));
    hash.put("tid", new String(HHMP, 2, 1));
    hash.put("eid", new String(HHMP, 3, 2));
    String eventData = new String(HHMP, 5, hhmsSize-5 );
    hash.put("edata", eventData);
    return hash;
  }

  /**
   *  get the hashtable and convert into HHMP byte[]
   *
   *  @param  hashtable
   *          return byte[]
   */
  public byte[] plaintoHHMP(Hashtable hash) {
    String mid = (String)hash.get("mid");
    String aid = (String)hash.get("aid");
    String tid = (String)hash.get("tid");
    String eid = (String)hash.get("eid");
    String edata = (String)hash.get("edata");
    int dataLength = edata.length();
    edata.trim();

    // make each information to one serial string and get the byte[]
    String strHHMP = new String(mid.concat(aid).concat(tid).concat(eid).concat(edata));
    byte[] HHMP = new byte[strHHMP.length()];
    HHMP = strHHMP.getBytes();

    return HHMP;
  }

  protected byte[] machineID = new byte[1];
  protected byte[] applicationID = new byte[1];
  protected byte[] topicID = new byte[1];
  protected byte[] eventID = new byte[2];
}