package com.anabas.pdasharedlet;

/**
 * Title:        PAdaptor.java
 * Description:  PDA Adaptor class.
 *               extends Thread as a daemon
 *               get HHms message from TCP/IP Server class and process it.
 * Copyright:    Copyright (c) 2001
 * Company:      CSIT FSU
 * @author       Sangyoon Oh soh@csit.fsu.edu
 *
 * @version 0.3: View change
 */

import java.awt.*;
import java.awt.Event;
import java.lang.*;
import java.util.*;

import com.anabas.sdsharedlet.*;

public class PAdaptor extends Thread {

  public void getGMSMessage(String messageType, String userName, String userID,
        String msg, char aID){

    System.out.println("[PDA-ADAPTOR] " + messageType + " " + userName + " " + userID + " " + msg);

    switch(aID) {
      case 'I': case 'i':
        break;
      case 'V': case 'v':
        svg.getGMSMessage(msg);
        break;
      case 'D': case 'd':
        // sd.getGMSMessage(messageType, userName, userID, msg);
        break;
      case 'C': case 'c':
        // im.getGMSMessage(messageType, userName, userID, msg);
        break;

      // Presentation View Change
      case 'P': case 'p':
        viewChange(msg);
        break;

      default:
        System.out.println("[PDA-ADAPTOR] ERROR: Un-Registered Application Message");
        break;
    }
  }

  public void getSDMessage(SDBitmap msg){
      sd.getGMSMessage(msg);
  }

  public void viewChange(String viewType) {

    // get changed command
    String ViewApp = new String(viewType.substring(24));
    System.out.println(ViewApp);

    // prepare send HHMP
    Hashtable hash = new Hashtable();
    hash.put("mid", "0");
    hash.put("tid", "0");
    hash.put("eid", "90");
    hash.put("edata", "test");

    if(ViewApp.equalsIgnoreCase("sd")){

      // set SD flag as true
      isSDChanged = true;

      hash.put("aid", "2");
      setHHMP(hash);
      pcv.SDStart();
    }
    else if(ViewApp.equalsIgnoreCase("garnetsvg")){

      // set SD flag as true
      isSDChanged = false;

      hash.put("aid", "1");
      setHHMP(hash);
      pcv.SDStop();
    }
    else {

      // set SD flag as true
      isSDChanged = false;

      pcv.SDStop();
    }
  }

  /**
  public void sendGMSMessage(String messageType, String userName, String userID,
              String msg){
      pcv.broadcastMessage(messageType, userName, userID, messageText, 0);
  }
  public void sendGMSMessage(String messageType, String userName, String userID,
              String msg){
      pcv.broadcastMessage(messageType, userName, userID, messageText, 1);
  }
  public void sendGMSMessage(String messageType, String userName, String userID,
              String msg){
      pcv.broadcastMessage(messageType, userName, userID, messageText, 2);
  }
  public void sendGMSMessage(String messageType, String userName, String userID,
              String msg){
      pcv.broadcastMessage(messageType, userName, userID, messageText, 3);
  }
  **/


  /**
   *  General HHMP message send Method
   */
  public void getHHMP(byte[] b, int i) {
    byte[] hhms = new byte[i];
    hhms = b;

    Hashtable hashMessage = hc.HHMPtoplain(hhms, i);
    String s = (String)hashMessage.get("aid");

    String eventM = (String)hashMessage.get("eid");
    String machineM = (String)hashMessage.get("mid");

    if(eventM.compareTo("99")==0) {
      String machineID = machineM + "machine";
      SocketHandler sh = (SocketHandler) this.Reghash.get("machineID");
      sh = null;
      this.Reghash.remove(machineID);
    }
    else {
      if(s.compareTo("0")==0) im.getMessage(hashMessage);
      else if(s.compareTo("1")==0) {
        String dataString = (String)hashMessage.get("edata");
          // svg.getMessage(hashMessage);
      }
      /**
      else if(s.compareTo("2")==0) {
        String eventString = (String)hashMessage.get("eid");
        if(eventString.compareTo("01") == 0) {
          pcv.SDStart();
        }
        else if(eventString.compareTo("99") == 0) {
          pcv.SDStop();
        }
      }
      else if(s.compareTo("3")==0) textchat.getMessage(hashMessage);
      **/
    }

    System.out.println("machineID " + hashMessage.get("mid"));
    System.out.println("applicationID " + hashMessage.get("aid"));
    System.out.println("topicID " + hashMessage.get("tid"));
    System.out.println("eventID " + hashMessage.get("eid"));
    System.out.println("eventData " + hashMessage.get("edata"));
  }

  /**
   *  General HHMP message send Method
   */
  public void setHHMP(Hashtable hs) {
    String s = (String)hs.get("edata");
    int size = s.length();
    byte[] hhmp = new byte[size + 5];
    hhmp = hc.plaintoHHMP(hs);
    String aid = (String) hs.get("aid");
    /**
    Hashtable temp = new Hashtable();
    if(aid.compareTo("0")==0) temp = Reghash;
    else if(aid.compareTo("1")==0) temp = Reghash;
    else if(aid.compareTo("2")==0) temp = Reghash;
    else if(aid.compareTo("3")==0) temp = Reghash;
    **/
    for (Enumeration e = Reghash.elements() ; e.hasMoreElements() ;) {
         sh = (SocketHandler)e.nextElement();
         sh.sendHHMP(hhmp);
         /**
         String ac = (String)hs.get("aid") + "AC";
         if(ac.compareTo(sh.APPLICATIONID)==0) sh.sendHHMP(hhmp);
         **/
    }
  }

  /**
   *  Send HHMP to PDA - SVG
   */
  public void setHHMP0(byte[] b) {
    Hashtable temp = new Hashtable();
    temp = Reghash;
    for (Enumeration e = temp.elements() ; e.hasMoreElements() ;) {
         sh = (SocketHandler)e.nextElement();
         sh.sendHHMP(b);
    }
  }

  /**
   *  Send HHMP to PDA - SD
   */

  public void setHHMP1(byte[] b) {
    Hashtable temp = new Hashtable();
    temp = Reghash;
    for (Enumeration e = temp.elements() ; e.hasMoreElements() ;) {
         sh = (SocketHandler)e.nextElement();
         sh.sendHHMP(b);
    }
  }

  /**
   *  Send HHMP to PDA - IM
   */
  public void setHHMP2(String s) {
    Hashtable temp = new Hashtable();
    temp = Reghash;

    for (Enumeration e = temp.elements() ; e.hasMoreElements() ;) {
         sh = (SocketHandler)e.nextElement();
         sh.sendHHMP(s.getBytes());
    }
  }

  public PAdaptor(PdaControlView o_pcv) {
    this.pcv = o_pcv;
    isSDChanged = false;
    run();
  }

  public void run() {
    tc = new TCPServer(this);
    tc.start();
  }

  // IMModule
  protected IMNet im = new IMNet(this);
  // SVGModule
  protected SVG svg = new SVG(this);
  // SDModule
  protected SD sd = new SD(this);

  public boolean isSDChanged;

  protected HHMPconverter hc = new HHMPconverter();
  public Hashtable Reghash = new Hashtable();

  public Hashtable IMhash = new Hashtable();
  public Hashtable SVGhash = new Hashtable();
  public Hashtable SDhash = new Hashtable();
  public Hashtable TextChathash = new Hashtable();

  protected TCPServer tc;
  protected SocketHandler sh;

  // Parent Class PdaControlView
  protected PdaControlView pcv;
}
