/*****************************************************************
     SD.java
        author        : Sangmi Lee (slee@csit.fsu.edu)
        last modified : May,30,2001
******************************************************************/
package com.anabas.pdasharedlet;

import com.sun.image.codec.jpeg.*;
import com.anabas.sdsharedlet.*;

import java.awt.*;
import java.io.*;
import java.awt.image.*;

public class SD{

     private DataInputStream inputM = null;
     private DataInputStream inputS = null;
     private DataOutputStream outputS = null;

     //Event message definitions
     private int EventMessage = 0;  // Sending message to Slave
     private int OpenEventBus = 1;  // First hand shaking with Slave
     private int UpdateImage = 2;   // Send new image to slave
     private int EndofImage = 3;    // Mark of End of image
     private int NoEvent = 0;       // There is no event

     private int TagLength = 5;
     private int intlength = 3;

     // key for hash table
     private byte mid  = (byte)2 ;
     private byte aid  = (byte)2 ;
     private byte tid  = (byte)0 ;
     private byte eid1 = (byte)0 ;
     private byte eid2 = (byte)0 ;


     private byte[]  message;

     SDRenderingEngine sdRE;
     HHMPUtil hu = new HHMPUtil();

     protected PAdaptor parent;
    
     protected boolean isChanged = false;

     public void getMessage (byte[] b) {
         //System.out.println(b[0]+ " " + b[1]+ " "+b[2]+ " "+b[3]+" "+b[4]+ " ");
         String str = new String(b);
         //System.out.println("getMesesage : "+str);
         mid  = b[0];
         aid  = b[1];
         tid  = b[2];
         eid1 = b[3];
         eid2 = b[4];
         ReceiveMessage();
     }


     public SD(PAdaptor _parent) {
         //System.out.println("SD_PDA Adaptor is running");
         parent = _parent;
         sdRE = new SDRenderingEngine(240,340,this);
     }



     public void SendMessage(int[] sendpixels, int width, int height, int event) {
         byte[] messagebyte = new byte[3+3+TagLength];
         messagebyte = 
               hu.GenerateHHMPmessage(mid, aid, tid, eid1, eid2, width, height, 6);
         parent.setHHMP1(messagebyte);


         messagebyte = new byte[(width*height)*3 + TagLength];
         messagebyte = 
               hu.GenerateHHMPmessage(mid,aid,tid,eid1,eid2,sendpixels,width*height);
         parent.setHHMP1(messagebyte);
             
    }


    public void ReceiveMessage(){
        byte[] eventbyte = new byte[2];
        eventbyte[0] = eid1;
        eventbyte[1] = eid2;
        String evt = new String(eventbyte);
        String evt1 = evt.substring(0,1);
        String evt2 = evt.substring(1,1);
        if (evt1.compareTo("3")==0) sdRE.ZoomImage(eid2);
        if (evt1.compareTo("9")==0) sdRE.ZoomImage(eid2);

        //System.out.println("receive int: " +(int)eid1 + " " + (int)eid2); 
        //System.out.println("receive string: " +evt1 + "evt2: " + evt2);  
    }

    public void getGMSMessage(SDBitmap m){ 
        //System.out.println("get GMS Message");                
        sdRE.GetUpdateImage(m);
    }
}



