/*****************************************************************
     SDRenderingEngine.java
        author        : Sangmi Lee (slee@csit.fsu.edu)
        last modified : June,11,2001
******************************************************************/

package com.anabas.pdasharedlet;

import com.sun.image.codec.jpeg.*;
import com.anabas.sdsharedlet.*;

import java.awt.*;
import java.io.*;
import java.awt.image.*;

class SDRenderingEngine extends Frame {
    private Image img = null;
    private int width = 0;
    private int height = 0;
    private Image resizedimg = null;
    private int resizedwidth = 240;
    private int resizedheight = 320;
    private int check = 0;
    private int[] pixels = null;
    private int[] originalpixels;
    protected PAdaptor parent;  
    private SD sdc;
    
    public SDRenderingEngine (int int1, int int2, SD sd) {
        resizedwidth = int1;
        resizedheight = int2;
        sdc = sd;
        //setSize(resizedwidth,resizedheight);
        //show();


    }
    
    public void update() {
        //repaint();
    }
  
  
    public void paint(Graphics g) {
        /*
	  if (img != null) {
                     
	     g.drawImage(img, 0, 20, resizedwidth, resizedheight - 20, this);
	  }
       */
    }

                   
    public void GetInitImage(){
 
        if (img != null) {
           try { 
               SendPixel(resizedwidth, resizedheight);
           }catch(Exception e){};
        }
    }
         


    public void GetUpdateImage(SDBitmap msg){
        //System.out.println("UpdateImage");

        ColorModel cm = ColorModel.getRGBdefault(); 
        MemoryImageSource source = new MemoryImageSource(msg.width, msg.height, 
                                                   cm, msg.data, 0, msg.width);          
  
        int[] pixels = new int[msg.width*msg.height];
        originalpixels = new int[msg.width*msg.height];       
        for(int i=0;i < msg.data.length/3;i++) {
             pixels[(msg.data.length/3)-(i+1)] = 
                         ((((int)msg.data[i*3])<<16)&0x00FF0000)+
		      	          ((((int)msg.data[i*3+1])<<8)&0x0000FF00)+
		             	           (int)msg.data[i*3+2];
			
        }
        for (int j = 0; j <msg.height; j++) {
              for (int k = 0; k< msg.width; k++) { 
                   originalpixels[j*msg.width+k] = pixels[j*msg.width+(msg.width-k-1)];
              }
        }
      
        MemoryImageSource source2 = 
                new MemoryImageSource(msg.width,msg.height,cm,originalpixels,0,msg.width);
        img = createImage(source2);
        width = msg.width;
        height = msg.height;

        ScaleImage(resizedheight, resizedwidth);
        RotateImage(resizedheight, resizedwidth);
        //System.out.println("SD Sends "+resizedwidth+" "+resizedheight);
        SendPixel(resizedwidth, resizedheight);
        //update();
         
    }

    public void ZoomImage(byte b){
        
        ColorModel cm = ColorModel.getRGBdefault(); 
        int zoomrate = (int)b;
        //System.out.println("zoomrate :"+zoomrate);
        if (zoomrate == 49) {
                  //System.out.println("zoomrate :"+zoomrate);
                  resizedwidth = 60;
                  resizedheight = 80;
        }

        if (zoomrate == 50) {

                  resizedwidth = 120;
                  resizedheight = 160;
        }
        if (zoomrate == 51) {
                  resizedwidth = 180;
                  resizedheight = 240;
        }
        if (zoomrate == 52) {
                  resizedwidth = 240;
                  resizedheight = 320;
        }
        if (zoomrate == 53) {
                  resizedwidth = 300;
                  resizedheight = 400;
        }
        if (zoomrate == 54) {
                  resizedwidth = 360;
                  resizedheight = 480;
        }
        if (zoomrate == 55) {
                  resizedwidth = 420;
                  resizedheight = 560;
        }
        if (zoomrate == 56) { 
                  resizedwidth = 480;
                  resizedheight = 640;
        }
        if (zoomrate == 57) {
                  resizedwidth = 240;
                  resizedheight = 320;
        }

        

       //.out.println("SD reset "+resizedwidth+" "+resizedheight);

     }


  
    public void ScaleImage(int rwidth, int rheight){
         
        MediaTracker media = new MediaTracker(this);
        media.addImage(img,0);
        try {
             media.waitForID(0);
             ImageFilter replicate = 
                   new ReplicateScaleFilter(rwidth,rheight);
             ImageProducer prod = 
                               new FilteredImageSource(img.getSource(),replicate);
             img = createImage(prod);
             
             
             media.addImage(img,1);
             media.waitForID(1);
        }
        catch(InterruptedException e) {}      
    }

 
    public void RotateImage(int w, int h){
        int[] rotate = new int[w * h];
        int[] pixels = new int[w * h];

        MediaTracker media = new MediaTracker(this);
        media.addImage(img,0);
        try {
             media.waitForID(0);
             PixelGrabber pg = new PixelGrabber(img, 0, 0, w,  
                                      h, pixels, 0, w);
             
             try{
                 pg.grabPixels();
             }
             catch(InterruptedException e) {
                 e.printStackTrace();
             }

               for (int y = 0; y < h ; y++) {
                 for (int x = 0; x <  w ; x++) {
                      rotate[((w-x-1)*h)+y] = 
                                 pixels[x+(y*w)];
                      
                 }
             }

             img = createImage(new MemoryImageSource(h, 
                                    w,rotate,0,h));

        }
        catch(Exception e) { e.printStackTrace(); }

    }


 
    public void SendPixel(int sendwidth, int sendheight) {
  
        BufferedImage bimg = null;
        int [] sendpixels = new int[sendwidth * sendheight];
        PixelGrabber pg = new PixelGrabber(img, 0, 0, sendwidth, sendheight, 
                                             sendpixels, 0, sendwidth);

        try {
               pg.grabPixels();
        }
        catch(InterruptedException ie) {
               ie.printStackTrace();
        }

        try {
              sdc.SendMessage(sendpixels,sendwidth,sendheight,0);
        }
        catch(Exception e) {}
      

          //for (int i = 0; i<resizedwidth*resizedheight; i++) pixels[i] = (pixels[i]|0xFF000000);

          //for(int i = 0 ; i < resizedwidth*resizedheight; i=i+3000 ) 
          //        System.out.println("Image pixels are, " +
          //                            pixels[i+0] + " " + pixels[i+1] + " " +
          //                            pixels[i+2] + " " + pixels[i+3]);
                    
          //try {
          //    sdc.SendMessage(pixels,resizedwidth,resizedheight,0);
          //    img.flush();
          //    img = createImage(new MemoryImageSource(resizedwidth, 
          //                          resizedheight,pixels,0,resizedwidth));


          //}
          //catch(Exception e) {}
    }
    
}       
