package com.anabas.pdasharedlet;

//  SVG.java 
//    auther : Sangmi Lee (slee@csit.fsu.edu)
//    purpose : control communication 
//    last update : April,29,2001


import java.net.*;
import java.io.*;
//import FileSharingControl;
//import SVGRenderingEngine;

public class SVG{

     private FileOutputStream outputfileM = null;
     private DataInputStream inputM = null;
     private FileInputStream inputfileS = null;
     private DataInputStream inputS = null;
     private DataOutputStream outputS = null;


     //Event message definitions
     private int EventMessage = 0;  // Sending message to Slave
     private int OpenEventBus = 1;  // First hand shaking with Slave
     private int UpdateImage = 2;   // Send new image to slave
     private int EndofImage = 3;    // Mark of End of image
     private int NoEvent = 0;       // There is no event 

     private int MessageLength = 64;
     private int DataLength = 59;
     private int TagLength = 5;
     private int M = 1; // assign 1 for master
     private int S = 2; // assign 2 for slave
     private int N = 0; // assign 0 for no use
     private int File1 = 1;
     private int File2 = 2;

     // key for hash table
     private byte mid = (byte)1;           // machine id
     private byte aid = (byte)1;           // application id
     private byte tid = (byte)0;          // topic id
     private byte[] eid = new byte[2];
     private byte eid1 =(byte)NoEvent;     // event
     private byte eid2 =(byte)NoEvent; 
     private byte[] edata = new byte[MessageLength];            
    
     private double originalsize = 230;
     private double currentsize = 230;

          //useful value definitions
     private int OK = 1;
     private int NG = 0;

     private FileSharingControl fsc;
     SVGRenderingEngine svgRE;
  
     protected PAdaptor parent;
     protected byte[] message = new byte[64];
     protected boolean isChanged = false;

     public void getMessage (byte[] b) {
    
         String str = new String(b);
         //System.out.println("getMesesage : "+str);
         mid  = b[0];
         aid  = b[1];
         tid  = b[2];
         eid1 = b[3];
         eid2 = b[4];
         ReceiveEvent();
     }


     public void ReceiveEvent(){
        byte[] eventbyte = new byte[2];
        eventbyte[0] = eid1;
        eventbyte[1] = eid2;
        String evt = new String(eventbyte);
        if (evt.compareTo("00")==0) InitImage();
       

        //System.out.println("receive int: " +(int)eid1 + " " + (int)eid2); 
        //System.out.println("receive string: " +evt1 + "evt2: " + evt2);  
    }


     public SVG(PAdaptor _parent) {
	    
	    //System.out.println("SVG_PDA Adaptor is started..");
          parent = _parent;
          init_rendering();
          //System.out.println("SVG_PDA Adaptor is running..end");
     }
     
     public void init_rendering() {
    
          
          fsc = new FileSharingControl();
          svgRE = new SVGRenderingEngine();

          fsc.FreeFile(File1);
          fsc.FreeFile(File2);
          //fsc.FileSharingStatus();
          
          
          //Socket Open for Slave
          //ServerSocket serversocketS = null;
          //Socket socketS = null;
          EventMessage = NoEvent;
          //System.out.println("SVG init_rendering is started.");
          //try {
          //    serversocketS = new ServerSocket(6000);
          // }
          //catch(IOException e){};
          //     try {
                  //socketS = serversocketS.accept();
                  //System.out.println("New Slave accepted " +
		      //   	                socketS.getInetAddress() +
			//      	          ":" + socketS.getPort());
 /*
             	fsc.LockFile(File1,S);
                  inputfileS = new FileInputStream("tmpout1.jpg");
              	System.out.println("check1");
              	//outputS = new DataOutputStream(socketS.getOutputStream());
              	//inputS = new DataInputStream(socketS.getInputStream());
              	System.out.println("check2");
                  try {
                      SendMessage(OpenEventBus);
                          //int receivedevent;
                          //receivedevent = ReceiveMessage();
                          
                      SendMessage(UpdateImage); 
                      SendMessage(EndofImage);
                      inputfileS.close(); 
                      //System.out.println("Finish sending image");
                      fsc.FreeFile(File1);
                      //fsc.FileSharingStatus();
                  }
                  catch(IOException e){};

           //     }
           //	catch(IOException e){};                
*/
     }


     public void InitImage() {
System.out.println("new file status : "+fsc.NewFileStatus() );
         if (fsc.NewFileStatus() == File1) { 
            this.SendData(File1);
         } else if (fsc.NewFileStatus() == File2) {
                this.SendData(File2);
           }
     }         
   
          
     
     public void SendData(int i) {
                 
                     String collstr = null;
                     String collmessagestring = null;
 
                
                   
                     byte[] collmessage = new byte[256];
                     collstr = null;
                     collmessagestring = null;
                     if ( i == File2 ) {
                        try {
                             fsc.LockFile(File2,S);        
                             //fsc.FileSharingStatus();
                             inputfileS = new FileInputStream("tmpout2.jpg");
                             try {
                                 SendMessage(OpenEventBus);
                                 SendMessage(UpdateImage); 
                                 SendMessage(EndofImage);
                                 inputfileS.close(); 
                                 //System.out.println("Finish sending image file2");
                                 fsc.FreeFile(File2);
                                 //fsc.FileSharingStatus();
                              }
                              catch(IOException e){};
                        }
                        catch(IOException e){};
                     }
                     else if ( i == File1) {
                             try {
                                  //System.out.println("start second thread");
                                  fsc.LockFile(File1,S); 
                                  //fsc.FileSharingStatus();                   
                                  inputfileS = new FileInputStream("tmpout1.jpg");
                                  try {
                                       SendMessage(OpenEventBus);
                                       SendMessage(UpdateImage); 
                                       SendMessage(EndofImage);
                                       inputfileS.close(); 
                                       //System.out.println("Finish sending image file1");
                                       fsc.FreeFile(File1);
                                       //fsc.FileSharingStatus();
                                   }
                                   catch(IOException e){};
                              }                 
                          
                              catch(IOException e){};
                     }                     


               
               
              
  }
          

 

      
   public int SendMessage(int i) {
          byte[] messagebyte = new byte[MessageLength];
          byte[] databyte = new byte[DataLength];
          // when PC sends a new image to PDA with event "update image" 
          try {
                     if ( i == UpdateImage) {
 
                        int j = 0;
                        while(( j=inputfileS.read(databyte))!=-1) {
                                messagebyte = new byte[MessageLength];
                                messagebyte[0] = mid;
                                messagebyte[1] = aid;
                                messagebyte[2] = tid;
                                messagebyte[3] = eid1;
                                messagebyte[4] = (byte)i;
                                for (int m = 0 ; m < DataLength ; m++) 
                                    messagebyte[m + TagLength] = databyte[m];
                                parent.setHHMP0(messagebyte);
                        } 
                     }
            // when PC sends only event messages (i.e. "open event bus", "end of image")
                     else {
                        messagebyte = new byte[MessageLength];
                        messagebyte[0] = mid;
                        messagebyte[1] = aid;
                        messagebyte[2] = tid;
                        messagebyte[3] = eid1;
                        messagebyte[4] = (byte) i;
                        parent.setHHMP0(messagebyte);
                       
                    
                     }
            }
            catch(IOException e){};        
                     return(1);
    }   
    
    public int ReceiveMessage(){
                try{
                    byte[] revent = new byte[1024];
                    inputS.read(revent);
                    int i = (int)revent[4];
                    return(i);
                }
                catch (IOException e){
                    System.out.println(e);}
                    return(0);
    }


    public void getGMSMessage(String m){
        
         //System.out.println("Start getmessage in SVG " + m);
         String eventstr = m.substring(0,1);
         String collstr = m.substring(1);  
         //         System.out.println("extracted string : " + collstr);
         if (eventstr.equals("1")) {
            currentsize = originalsize;
            svgRE.GetSVG(collstr);
            if ( (fsc.NewFileStatus() == File1)||(fsc.NewFileStatus() == 0) ) { 
               fsc.LockFile(File2,M);
               svgRE.SVGRender("tmpout.svg", "tmpout2.jpg",currentsize);
               fsc.FreeFile(File2);
               //fsc.FileSharingStatus();
               fsc.MarkNewFile(File2);
               this.SendData(File2);

            }
            else if (fsc.NewFileStatus() == File2) {
               fsc.LockFile(File1,M);
               svgRE.GetSVG(collstr);
               svgRE.SVGRender("tmpout.svg","tmpout1.jpg",currentsize);
               fsc.FreeFile(File1);
               //fsc.FileSharingStatus();
               fsc.MarkNewFile(File1);
               //System.out.println("check else");
               this.SendData(File1);
            }
         }         
         if (eventstr.equals("2")) { //zoomin
             currentsize = currentsize*1.2;
             if ( (fsc.NewFileStatus() == File1)||(fsc.NewFileStatus() == 0) ) { 
               fsc.LockFile(File2,M);
               svgRE.SVGRender("tmpout.svg", "tmpout2.jpg",currentsize);
               fsc.FreeFile(File2);
               //fsc.FileSharingStatus();
               fsc.MarkNewFile(File2);
               this.SendData(File2);

             }
             else if (fsc.NewFileStatus() == File2) {
               fsc.LockFile(File1,M);
               svgRE.GetSVG(collstr);
               svgRE.SVGRender("tmpout.svg","tmpout1.jpg",currentsize);
               fsc.FreeFile(File1);
               //fsc.FileSharingStatus();
               fsc.MarkNewFile(File1);
               //System.out.println("check else");
               this.SendData(File1);
             }
   
         }
         if (eventstr.equals("3")) { //zoomout
             currentsize = currentsize/1.2; 
             if ( (fsc.NewFileStatus() == File1)||(fsc.NewFileStatus() == 0) ) { 
               fsc.LockFile(File2,M);
               svgRE.SVGRender("tmpout.svg", "tmpout2.jpg",currentsize);
               fsc.FreeFile(File2);
               //fsc.FileSharingStatus();
               fsc.MarkNewFile(File2);
               this.SendData(File2);

             }
             else if (fsc.NewFileStatus() == File2) {
               fsc.LockFile(File1,M);
               svgRE.GetSVG(collstr);
               svgRE.SVGRender("tmpout.svg","tmpout1.jpg",currentsize);
               fsc.FreeFile(File1);
               //fsc.FileSharingStatus();
               fsc.MarkNewFile(File1);
               //System.out.println("check else");
               this.SendData(File1);
             }
                  

          }

    }
  
   

  
   
  
}
